/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.person.entity;

@javax.persistence.NamedQueries(
 {



   
 }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "KONTOVERBINDUNG")
// @javax.persistence.IdClass(KontoverbindungPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Kontoverbindung
extends AbstractKontoverbindung
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Kontoverbindung() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Kontoverbindung(Kontoverbindung original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "kontoverbindung_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Kontoverbindung")
    @javax.persistence.TableGenerator(name = "Kontoverbindung", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Kontoverbindung", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient KontoverbindungPK pkCache;

  @Override
  public KontoverbindungPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new KontoverbindungPK(getId());
    }

    return pkCache;
  }

  public static <E extends Kontoverbindung> java.util.Map<KontoverbindungPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<KontoverbindungPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Kontoverbindung> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedBankleitzahl = false;
          hasChangedBic = false;
          hasChangedIban = false;
          hasChangedIbanBearbeiter = false;
          hasChangedIbanVorAenderung = false;
          hasChangedKontoinhaber = false;
          hasChangedKontonummer = false;
          hasChangedKreditinstitut = false;
  


        
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "BANKLEITZAHL", nullable = KontoverbindungConstants.BANKLEITZAHL_NULLABLE, length=KontoverbindungConstants.BANKLEITZAHL_MAX_LENGTH)
        
  protected java.lang.String bankleitzahl =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBankleitzahl = false;

  public boolean hasChangedBankleitzahl(){
    return hasChangedBankleitzahl;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBankleitzahl = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBankleitzahl;
  
  /**
   * 
   *
   * getter for KONTOVERBINDUNG.BANKLEITZAHL
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBankleitzahl() {
        return bankleitzahl;
      }

  /**
   * 
   *
   * setter for KONTOVERBINDUNG.BANKLEITZAHL
   *
   * @param bankleitzahl
   */
  @Override   public void setBankleitzahl(@javax.annotation.Nullable  java.lang.String bankleitzahl) {

       resetTkCache();
                  
                          java.lang.String bankleitzahlInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bankleitzahl, KontoverbindungConstants.BANKLEITZAHL_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bankleitzahl
      , bankleitzahlInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBankleitzahl |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bankleitzahl");
      }


             if (!isSeitLadenVeraendertBankleitzahl) {
          isSeitLadenVeraendertBankleitzahl = thisAttributChanged;
         if (isSeitLadenVeraendertBankleitzahl){
           wertNachLadenBankleitzahl=this.bankleitzahl;
         }
       }
      

       this.bankleitzahl = bankleitzahlInternal;

         }

        
  @javax.persistence.Column(name = "BIC", nullable = KontoverbindungConstants.BIC_NULLABLE, length=KontoverbindungConstants.BIC_MAX_LENGTH)
        
  protected java.lang.String bic =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBic = false;

  public boolean hasChangedBic(){
    return hasChangedBic;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBic = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBic;
  
  /**
   * 
   *
   * getter for KONTOVERBINDUNG.BIC
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBic() {
        return bic;
      }

  /**
   * 
   *
   * setter for KONTOVERBINDUNG.BIC
   *
   * @param bic
   */
  @Override   public void setBic(@javax.annotation.Nullable  java.lang.String bic) {

       resetTkCache();
                  
                          java.lang.String bicInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bic, KontoverbindungConstants.BIC_MAX_LENGTH, getId(), getClass());
                  
                java.lang.String alterWert = getBic();
         bicInternal = preProcessBic(bicInternal);
         preSetBic(alterWert, bicInternal);
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bic
      , bicInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBic |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bic");
      }


             if (!isSeitLadenVeraendertBic) {
          isSeitLadenVeraendertBic = thisAttributChanged;
         if (isSeitLadenVeraendertBic){
           wertNachLadenBic=this.bic;
         }
       }
      

       this.bic = bicInternal;

                postSetBic(alterWert, bicInternal);
         }

  
    @Override
    protected java.lang.String preProcessBic(java.lang.String neuerWert) {
      return super.preProcessBic(neuerWert);
    }

    @Override
    protected void preSetBic(java.lang.String alterWert, java.lang.String neuerWert) {
      super.preSetBic(alterWert, neuerWert);
    }

    @Override
    protected void postSetBic(java.lang.String alterWert, java.lang.String neuerWert) {
      super.postSetBic(alterWert, neuerWert);
    }
        
  @javax.persistence.Column(name = "IBAN", nullable = KontoverbindungConstants.IBAN_NULLABLE, length=KontoverbindungConstants.IBAN_MAX_LENGTH)
        
  protected java.lang.String iban =  null;

  @javax.persistence.Transient
  protected boolean hasChangedIban = false;

  public boolean hasChangedIban(){
    return hasChangedIban;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertIban = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenIban;
  
  /**
   * 
   *
   * getter for KONTOVERBINDUNG.IBAN
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getIban() {
        return iban;
      }

  /**
   * 
   *
   * setter for KONTOVERBINDUNG.IBAN
   *
   * @param iban
   */
  @Override   public void setIban(@javax.annotation.Nullable  java.lang.String iban) {

       resetTkCache();
                  
                          java.lang.String ibanInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(iban, KontoverbindungConstants.IBAN_MAX_LENGTH, getId(), getClass());
                  
                java.lang.String alterWert = getIban();
         ibanInternal = preProcessIban(ibanInternal);
         preSetIban(alterWert, ibanInternal);
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.iban
      , ibanInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedIban |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("iban");
      }


             if (!isSeitLadenVeraendertIban) {
          isSeitLadenVeraendertIban = thisAttributChanged;
         if (isSeitLadenVeraendertIban){
           wertNachLadenIban=this.iban;
         }
       }
      

       this.iban = ibanInternal;

                postSetIban(alterWert, ibanInternal);
         }

  
    @Override
    protected java.lang.String preProcessIban(java.lang.String neuerWert) {
      return super.preProcessIban(neuerWert);
    }

    @Override
    protected void preSetIban(java.lang.String alterWert, java.lang.String neuerWert) {
      super.preSetIban(alterWert, neuerWert);
    }

    @Override
    protected void postSetIban(java.lang.String alterWert, java.lang.String neuerWert) {
      super.postSetIban(alterWert, neuerWert);
    }
        
  @javax.persistence.Column(name = "IBAN_BEARBEITER", nullable = KontoverbindungConstants.IBAN_BEARBEITER_NULLABLE, length=KontoverbindungConstants.IBAN_BEARBEITER_MAX_LENGTH)
        
  protected java.lang.String ibanBearbeiter =  null;

  @javax.persistence.Transient
  protected boolean hasChangedIbanBearbeiter = false;

  public boolean hasChangedIbanBearbeiter(){
    return hasChangedIbanBearbeiter;
  }
  
  /**
   * 
   *
   * getter for KONTOVERBINDUNG.IBAN_BEARBEITER
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getIbanBearbeiter() {
        return ibanBearbeiter;
      }

  /**
   * 
   *
   * setter for KONTOVERBINDUNG.IBAN_BEARBEITER
   *
   * @param ibanBearbeiter
   */
  @Override   public void setIbanBearbeiter(@javax.annotation.Nullable  java.lang.String ibanBearbeiter) {

       resetTkCache();
                  
                          java.lang.String ibanBearbeiterInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(ibanBearbeiter, KontoverbindungConstants.IBAN_BEARBEITER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ibanBearbeiter
      , ibanBearbeiterInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedIbanBearbeiter |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ibanBearbeiter");
      }


      

       this.ibanBearbeiter = ibanBearbeiterInternal;

         }

        
  @javax.persistence.Column(name = "IBAN_ZU_BESTAETIGEN", nullable = KontoverbindungConstants.IBAN_ZU_BESTAETIGEN_NULLABLE, length=KontoverbindungConstants.IBAN_ZU_BESTAETIGEN_MAX_LENGTH)
        
  protected java.lang.String ibanVorAenderung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedIbanVorAenderung = false;

  public boolean hasChangedIbanVorAenderung(){
    return hasChangedIbanVorAenderung;
  }
  
  /**
   * 
   *
   * getter for KONTOVERBINDUNG.IBAN_ZU_BESTAETIGEN
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getIbanVorAenderung() {
        return ibanVorAenderung;
      }

  /**
   * 
   *
   * setter for KONTOVERBINDUNG.IBAN_ZU_BESTAETIGEN
   *
   * @param ibanVorAenderung
   */
  @Override   public void setIbanVorAenderung(@javax.annotation.Nullable  java.lang.String ibanVorAenderung) {

       resetTkCache();
                  
                          java.lang.String ibanVorAenderungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(ibanVorAenderung, KontoverbindungConstants.IBAN_ZU_BESTAETIGEN_MAX_LENGTH, getId(), getClass());
                  
                java.lang.String alterWert = getIbanVorAenderung();
         ibanVorAenderungInternal = preProcessIbanVorAenderung(ibanVorAenderungInternal);
         preSetIbanVorAenderung(alterWert, ibanVorAenderungInternal);
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ibanVorAenderung
      , ibanVorAenderungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedIbanVorAenderung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ibanVorAenderung");
      }


      

       this.ibanVorAenderung = ibanVorAenderungInternal;

                postSetIbanVorAenderung(alterWert, ibanVorAenderungInternal);
         }

  
    @Override
    protected java.lang.String preProcessIbanVorAenderung(java.lang.String neuerWert) {
      return super.preProcessIbanVorAenderung(neuerWert);
    }

    @Override
    protected void preSetIbanVorAenderung(java.lang.String alterWert, java.lang.String neuerWert) {
      super.preSetIbanVorAenderung(alterWert, neuerWert);
    }

    @Override
    protected void postSetIbanVorAenderung(java.lang.String alterWert, java.lang.String neuerWert) {
      super.postSetIbanVorAenderung(alterWert, neuerWert);
    }
        
  @javax.persistence.Column(name = "KONTOINHABER", nullable = KontoverbindungConstants.KONTOINHABER_NULLABLE, length=KontoverbindungConstants.KONTOINHABER_MAX_LENGTH)
        
  protected java.lang.String kontoinhaber =  null;

  @javax.persistence.Transient
  protected boolean hasChangedKontoinhaber = false;

  public boolean hasChangedKontoinhaber(){
    return hasChangedKontoinhaber;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertKontoinhaber = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenKontoinhaber;
  
  /**
   * 
   *
   * getter for KONTOVERBINDUNG.KONTOINHABER
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getKontoinhaber() {
        return kontoinhaber;
      }

  /**
   * 
   *
   * setter for KONTOVERBINDUNG.KONTOINHABER
   *
   * @param kontoinhaber
   */
  @Override   public void setKontoinhaber(@javax.annotation.Nullable  java.lang.String kontoinhaber) {

       resetTkCache();
                  
                          java.lang.String kontoinhaberInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(kontoinhaber, KontoverbindungConstants.KONTOINHABER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.kontoinhaber
      , kontoinhaberInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedKontoinhaber |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("kontoinhaber");
      }


             if (!isSeitLadenVeraendertKontoinhaber) {
          isSeitLadenVeraendertKontoinhaber = thisAttributChanged;
         if (isSeitLadenVeraendertKontoinhaber){
           wertNachLadenKontoinhaber=this.kontoinhaber;
         }
       }
      

       this.kontoinhaber = kontoinhaberInternal;

         }

        
  @javax.persistence.Column(name = "KONTONUMMER", nullable = KontoverbindungConstants.KONTONUMMER_NULLABLE, length=KontoverbindungConstants.KONTONUMMER_MAX_LENGTH)
        
  protected java.lang.String kontonummer =  null;

  @javax.persistence.Transient
  protected boolean hasChangedKontonummer = false;

  public boolean hasChangedKontonummer(){
    return hasChangedKontonummer;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertKontonummer = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenKontonummer;
  
  /**
   * 
   *
   * getter for KONTOVERBINDUNG.KONTONUMMER
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getKontonummer() {
        return kontonummer;
      }

  /**
   * 
   *
   * setter for KONTOVERBINDUNG.KONTONUMMER
   *
   * @param kontonummer
   */
  @Override   public void setKontonummer(@javax.annotation.Nullable  java.lang.String kontonummer) {

       resetTkCache();
                  
                          java.lang.String kontonummerInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(kontonummer, KontoverbindungConstants.KONTONUMMER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.kontonummer
      , kontonummerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedKontonummer |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("kontonummer");
      }


             if (!isSeitLadenVeraendertKontonummer) {
          isSeitLadenVeraendertKontonummer = thisAttributChanged;
         if (isSeitLadenVeraendertKontonummer){
           wertNachLadenKontonummer=this.kontonummer;
         }
       }
      

       this.kontonummer = kontonummerInternal;

         }

        
  @javax.persistence.Column(name = "KREDITINSTITUT", nullable = KontoverbindungConstants.KREDITINSTITUT_NULLABLE, length=KontoverbindungConstants.KREDITINSTITUT_MAX_LENGTH)
        
  protected java.lang.String kreditinstitut =  null;

  @javax.persistence.Transient
  protected boolean hasChangedKreditinstitut = false;

  public boolean hasChangedKreditinstitut(){
    return hasChangedKreditinstitut;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertKreditinstitut = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenKreditinstitut;
  
  /**
   * 
   *
   * getter for KONTOVERBINDUNG.KREDITINSTITUT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getKreditinstitut() {
        return kreditinstitut;
      }

  /**
   * 
   *
   * setter for KONTOVERBINDUNG.KREDITINSTITUT
   *
   * @param kreditinstitut
   */
  @Override   public void setKreditinstitut(@javax.annotation.Nullable  java.lang.String kreditinstitut) {

       resetTkCache();
                  
                          java.lang.String kreditinstitutInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(kreditinstitut, KontoverbindungConstants.KREDITINSTITUT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.kreditinstitut
      , kreditinstitutInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedKreditinstitut |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("kreditinstitut");
      }


             if (!isSeitLadenVeraendertKreditinstitut) {
          isSeitLadenVeraendertKreditinstitut = thisAttributChanged;
         if (isSeitLadenVeraendertKreditinstitut){
           wertNachLadenKreditinstitut=this.kreditinstitut;
         }
       }
      

       this.kreditinstitut = kreditinstitutInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Kontoverbindung:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Kontoverbindung other){
                             other.bankleitzahl = this.bankleitzahl;
                                other.bic = this.bic;
                                other.iban = this.iban;
                                other.ibanBearbeiter = this.ibanBearbeiter;
                                other.ibanVorAenderung = this.ibanVorAenderung;
                                other.kontoinhaber = this.kontoinhaber;
                                other.kontonummer = this.kontonummer;
                                other.kreditinstitut = this.kreditinstitut;
           
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Kontoverbindung.class)){
        copyEntityAttributesUsingSetter((Kontoverbindung) other.castTo(Kontoverbindung.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Kontoverbindung: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Kontoverbindung other){
               other.setBankleitzahl(this.bankleitzahl);
                  other.setBic(this.bic);
                  other.setIban(this.iban);
                  other.setIbanBearbeiter(this.ibanBearbeiter);
                  other.setIbanVorAenderung(this.ibanVorAenderung);
                  other.setKontoinhaber(this.kontoinhaber);
                  other.setKontonummer(this.kontonummer);
                  other.setKreditinstitut(this.kreditinstitut);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Kontoverbindung other){
                       if (hasChangedBankleitzahl) {
        other.setBankleitzahl(this.bankleitzahl);
      }
                             if (hasChangedBic) {
        other.setBic(this.bic);
      }
                             if (hasChangedIban) {
        other.setIban(this.iban);
      }
                             if (hasChangedIbanBearbeiter) {
        other.setIbanBearbeiter(this.ibanBearbeiter);
      }
                             if (hasChangedIbanVorAenderung) {
        other.setIbanVorAenderung(this.ibanVorAenderung);
      }
                             if (hasChangedKontoinhaber) {
        other.setKontoinhaber(this.kontoinhaber);
      }
                             if (hasChangedKontonummer) {
        other.setKontonummer(this.kontonummer);
      }
                             if (hasChangedKreditinstitut) {
        other.setKreditinstitut(this.kreditinstitut);
      }
             }





    @javax.persistence.Transient
    private transient KontoverbindungTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public KontoverbindungTK getKontoverbindungTK(){
    if (tkCache==null) {
    tkCache = new KontoverbindungTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getKontoverbindungTK();
    }

  @Override
  public KontoverbindungUK getUk(){
    return getKontoverbindungUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Kontoverbindung.class;
  }

public KontoverbindungUK getKontoverbindungUK(){

   return  new KontoverbindungUK(



  );
}

  @javax.persistence.Transient
  private transient KontoverbindungProperties properties;

  public KontoverbindungProperties getProperties(){
    if (properties == null) {
      properties = new KontoverbindungProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public KontoverbindungProperties getKontoverbindungProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return KontoverbindungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(KontoverbindungConstants.MESSAGE_KEY_BANKLEITZAHL_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(KontoverbindungConstants.MESSAGE_KEY_BANKLEITZAHL_EINZAHL);

        bankleitzahl =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(KontoverbindungConstants.MESSAGE_KEY_BIC_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(KontoverbindungConstants.MESSAGE_KEY_BIC_EINZAHL);

        bic =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(KontoverbindungConstants.MESSAGE_KEY_IBAN_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(KontoverbindungConstants.MESSAGE_KEY_IBAN_EINZAHL);

        iban =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                            
      if (werteVorher.containsKey(KontoverbindungConstants.MESSAGE_KEY_KONTOINHABER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(KontoverbindungConstants.MESSAGE_KEY_KONTOINHABER_EINZAHL);

        kontoinhaber =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(KontoverbindungConstants.MESSAGE_KEY_KONTONUMMER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(KontoverbindungConstants.MESSAGE_KEY_KONTONUMMER_EINZAHL);

        kontonummer =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(KontoverbindungConstants.MESSAGE_KEY_KREDITINSTITUT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(KontoverbindungConstants.MESSAGE_KEY_KREDITINSTITUT_EINZAHL);

        kreditinstitut =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBankleitzahl) {
      result.put(KontoverbindungConstants.MESSAGE_KEY_BANKLEITZAHL_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBankleitzahl , bankleitzahl));
    }
                            if (isSeitLadenVeraendertBic) {
      result.put(KontoverbindungConstants.MESSAGE_KEY_BIC_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBic , bic));
    }
                            if (isSeitLadenVeraendertIban) {
      result.put(KontoverbindungConstants.MESSAGE_KEY_IBAN_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenIban , iban));
    }
                                                                    if (isSeitLadenVeraendertKontoinhaber) {
      result.put(KontoverbindungConstants.MESSAGE_KEY_KONTOINHABER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenKontoinhaber , kontoinhaber));
    }
                            if (isSeitLadenVeraendertKontonummer) {
      result.put(KontoverbindungConstants.MESSAGE_KEY_KONTONUMMER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenKontonummer , kontonummer));
    }
                            if (isSeitLadenVeraendertKreditinstitut) {
      result.put(KontoverbindungConstants.MESSAGE_KEY_KREDITINSTITUT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenKreditinstitut , kreditinstitut));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBankleitzahl = false;
      wertNachLadenBankleitzahl = null;
                          isSeitLadenVeraendertBic = false;
      wertNachLadenBic = null;
                          isSeitLadenVeraendertIban = false;
      wertNachLadenIban = null;
                                                          isSeitLadenVeraendertKontoinhaber = false;
      wertNachLadenKontoinhaber = null;
                          isSeitLadenVeraendertKontonummer = false;
      wertNachLadenKontonummer = null;
                          isSeitLadenVeraendertKreditinstitut = false;
      wertNachLadenKreditinstitut = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "KONTOVERBINDUNG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Kontoverbindung";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(KontoverbindungConstants.BANKLEITZAHL_MAX_LENGTH ,  bankleitzahl, this, KontoverbindungConstants.MESSAGE_KEY_BANKLEITZAHL_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(KontoverbindungConstants.BIC_MAX_LENGTH ,  bic, this, KontoverbindungConstants.MESSAGE_KEY_BIC_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(KontoverbindungConstants.IBAN_MAX_LENGTH ,  iban, this, KontoverbindungConstants.MESSAGE_KEY_IBAN_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(KontoverbindungConstants.IBAN_BEARBEITER_MAX_LENGTH ,  ibanBearbeiter, this, KontoverbindungConstants.MESSAGE_KEY_IBAN_BEARBEITER_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(KontoverbindungConstants.IBAN_ZU_BESTAETIGEN_MAX_LENGTH ,  ibanVorAenderung, this, KontoverbindungConstants.MESSAGE_KEY_IBAN_ZU_BESTAETIGEN_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(KontoverbindungConstants.KONTOINHABER_MAX_LENGTH ,  kontoinhaber, this, KontoverbindungConstants.MESSAGE_KEY_KONTOINHABER_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(KontoverbindungConstants.KONTONUMMER_MAX_LENGTH ,  kontonummer, this, KontoverbindungConstants.MESSAGE_KEY_KONTONUMMER_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(KontoverbindungConstants.KREDITINSTITUT_MAX_LENGTH ,  kreditinstitut, this, KontoverbindungConstants.MESSAGE_KEY_KREDITINSTITUT_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
